var TUB = exports ? exports : {}; // require or Ti.include

TUB.byId = {};

TUB.base = {};

/*
TUB.iOS = (Ti.Platform.name == 'iPhone OS') ? Ti.Platform.version : 0;
TUB.iPhone = (Ti.Platform.name == 'iPhone OS' && Ti.Platform.osname != 'iPad') ? Ti.Platform.version : 0;
TUB.iPad = (Ti.Platform.name == 'iPhone OS' && Ti.Platform.osname == 'iPad') ? Ti.Platform.version : 0;
TUB.android = (Ti.Platform.name == 'android') ? Ti.Platform.version : 0;
//TUB.blackberry = (Ti.Platform.name == 'blackberry') ? Ti.Platform.version : 0;

TUB.base.for_iOS = TUB.iOS ? {} : {unsupport:true, color:'#666'};
TUB.base.for_iOS32 = (TUB.iOS >= 3.2) ? {} : {unsupport:true, color:'#666'};
TUB.base.for_iOS4 = (TUB.iOS >= 4.0) ? {} : {unsupport:true, color:'#666'};
TUB.base.for_iPhone = TUB.iPhone ? {} : {unsupport:true, color:'#666'};
TUB.base.for_iPad = TUB.iPad ? {} : {unsupport:true, color:'#666'};
TUB.base.for_iOS_not_iPad = (TUB.iOS && ! TUB.iPad) ? {} : {unsupport:true, color:'#666'};

TUB.base.for_android = TUB.android ? {} : {unsupport:true, color:'#666'};

TUB.base.hidden = {visible:false};
TUB.base.disabled = {enabled:false};
TUB.base.touchDisabled = {touchEnabled:false};

TUB.base.hasCheck = {hasCheck:true};
TUB.base.hasChild = {hasChild:true};
TUB.base.hasDetail = {hasDetail:true};
*/

TUB.isArray = function (value) {
	return typeof(value) == 'object' && typeof(value.length) == 'number';
}

TUB.merge = function (values1, values2) {
	var values = {};
	for (var n = 0; n < arguments.length; n++) {
		if (! TUB.isArray(arguments[n])) { continue; }
		for (var name in arguments[n]) { values[name] = arguments[n][name]; }
	}
	return values;
}

TUB.buildUI = function (node) {
	if (typeof(node) == 'string') {
		node = Ti.XML.parseString(Ti.Filesystem.getFile(node).read().text).documentElement;
	}
	var params = {};
	var base = node.base ? node.base.split(' ') : [];
	for (var n = 0; n < base.length; n++) {
		for (var name in TUB.base[base[n]]) { params[name] = TUB.base[base[n]][name]; }
	}
	for (var name in node.params) { params[name] = node.params[name]; }
	var doneIndex = -1;
	for (var n = 0; node.children && n < node.children.length; n++) {
		var item = node.children[n];
		if ((node.ui != 'Tab' && node.ui != 'NavigationGroup') || item.ui != 'Window') { continue; }
		params.window = TUB.buildUI(item);
		doneIndex = n;
		break;
	}
	var packages = [ Ti.UI, Ti.UI.iOS, Ti.UI.iPhone, Ti.UI.iPad, Ti.UI.Android, Ti.UI.Android.OptionMenu, Ti.Media, Ti.Facebook ];
	var factory = null;
	for (var n = 0; ! factory && n < packages.length; n++) {
		if (packages[n] && packages[n]['create' + node.ui]) { factory = packages[n]['create' + node.ui]; break; }
	}
	var obj = (node.ui == 'CurrentWindow') ? Ti.UI.currentWindow : factory ? factory(params) : [];
	for (var name in node.events) {
		if (TUB.isArray(obj)) { continue; }
		obj.addEventListener(name, typeof(node.events[name]) == 'function' ? node.events[name] : new Function("e", node.events[name]));
	}
	for (var n = 0; node.children && n < node.children.length; n++) {
		var item = node.children[n];
		if (n == doneIndex) { continue; }
		var child = TUB.buildUI(item);
		if (TUB.isArray(obj)) {
			obj.push(child);
		} else if (node.ui == 'TabGroup' && item.ui == 'Tab') {
			obj.addTab(child);
//		} else if (node.ui == 'Window' && item.ui == 'View') {
//			obj.addView(child);
		} else if (node.ui == 'TableView' && item.ui == 'TableViewRow') {
			obj.appendRow(child);
		} else if (node.ui == 'TableView' && item.ui == 'SearchBar') {
			obj.search = child;
		} else if (node.ui == 'PickerColumn' && item.ui == 'PickerRow') {
			obj.addRow(child);
		} else {
			obj.add(child);
		}
	}
	if (params.id && ! TUB.isArray(obj)) { TUB.byId[params.id] = obj; }
	return obj;
};

TUB.evalInterval = function (codes, interval) {
	var code = codes.shift();
	if (typeof(code) == 'function') { code(); } else { eval(code); }
	if (codes.length) { setTimeout(function () { TUB.evalInterval(codes, interval); }, interval); }
}

TUB.autoCloseMessage = function (win, label, texts, interval) {
	if (! TUB.isArray(texts)) { texts = [texts]; }
	var codes = [];
	codes.push(function () { label.text = texts.shift(); win.open(); });
	for (var n = 1; n < texts.length; n++) { codes.push(function () { label.text = texts.shift(); }); }
	codes.push(function () { win.close({opacity:0, duration:500}); });
	TUB.evalInterval(codes, interval ? interval : 1000);
};

TUB.alert = function () {
	var params = (arguments.length == 0) ? {message:'Alert', buttonNames:['OK']}
	 : (typeof(arguments[0]) == 'object') ? arguments[0]
	 : (arguments.length == 1) ? {message:arguments[0], buttonNames:['OK']}
	 : (arguments.length == 2) ? {title:arguments[0], message:arguments[1], buttonNames:['OK']}
	 : (arguments.length == 3) ? {title:arguments[0], message:arguments[1], buttonNames:arguments[2]}
	 : {title:arguments[0], message:arguments[1], buttonNames:arguments[2], cancel:arguments[3]};
	Ti.UI.createAlertDialog(params).show();
};

TUB.notify = function () {
	var params = (arguments.length == 0) ? {message:'Notify'}
	 : (typeof(arguments[0]) == 'object') ? arguments[0] : {message:arguments[0]};
	Ti.UI.createNotification(params).show();
};

TUB.openWindow = function (source, params) {
	if (! params) { params = {}; }
	if (source.title) { params.title = source.title; }
	if (source.href) { params.url = source.href; }
	for (var name in source.params) { params[name] = source.params[name]; }
	var root = Ti.Filesystem.getFile(Ti.Filesystem.resourcesDirectory).nativePath;
	var file = (params.url[0] == '/') ? Ti.Filesystem.getFile(root, params.url) : Ti.Filesystem.getFile(params.url)
	if (! params.title || ! params.url || ! file.exists()) {
		TUB.alert('System Error', 'file ' + params.url + ' not found.');
		return;
	}
	var win = Ti.UI.createWindow(params);
//	if (params.tabBar == 'hide') { win.hideTabBar(); }
	Ti.UI.currentTab.open(win, { animated:true });
};

TUB.buildMenu = function (data, params) {
	for (var n = 0; n < data.length; n++) { data[n].hasChild = true; }
	return TUB.buildUI({ ui : "TableView", params : { data : data },
	 events : { click : function (e) { TUB.openWindow(e.rowData, params); } } });
};
